# coding: utf-8

"""
    Magneto API

    Magneto API is the RESTful API for the Rely.io platform.

    The version of the OpenAPI document: v0.0.1
    Contact: contact@rely.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from magneto_api_client.models.aggregation_calculate_by import AggregationCalculateBy
from magneto_api_client.models.aggregation_filter import AggregationFilter
from magneto_api_client.models.aggregation_function import AggregationFunction
from typing import Optional, Set
from typing_extensions import Self

class Aggregation(BaseModel):
    """
    Aggregation
    """ # noqa: E501
    function: AggregationFunction
    calculated_by: AggregationCalculateBy = Field(alias="calculatedBy")
    target_blueprint: StrictStr = Field(alias="targetBlueprint")
    target_property: Optional[StrictStr] = Field(default=None, alias="targetProperty")
    measure_time_by: Optional[StrictStr] = Field(default=None, alias="measureTimeBy")
    filters: Optional[List[AggregationFilter]] = None
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["function", "calculatedBy", "targetBlueprint", "targetProperty", "measureTimeBy", "filters"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Aggregation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in filters (list)
        _items = []
        if self.filters:
            for _item_filters in self.filters:
                if _item_filters:
                    _items.append(_item_filters.to_dict())
            _dict['filters'] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Aggregation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "function": obj.get("function"),
            "calculatedBy": obj.get("calculatedBy"),
            "targetBlueprint": obj.get("targetBlueprint"),
            "targetProperty": obj.get("targetProperty"),
            "measureTimeBy": obj.get("measureTimeBy"),
            "filters": [AggregationFilter.from_dict(_item) for _item in obj["filters"]] if obj.get("filters") is not None else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


